#include "llmod.as"
#include "multiopen.as"

#uselib "Exforce.dll"
#func extract extract 5
#func sxtime sxtime 5
#func enable enable 2

#uselib "hspcmp.dll"
#func hsc_ini hsc_ini 6
#func hsc_refname hsc_refname 6
#func hsc_objname hsc_objname 6
#func hsc_comp hsc_comp 0
#func hsc_getmes hsc_getmes 1
#func pack_ini pack_ini 6
#func pack_make pack_make 0
#func pack_exe pack_exe 0
#func pack_opt pack_opt 0
#func pack_rt pack_rt 6

#define buf_size  512
#define info_size 128

#define MESSEGE "Message"
#define WARNING "Warning"
#define _CLOSE ""
#define _CANSEL "ݾ"
#define _OK "OK"
#define _MAKE "쐬܂B"
#define _NOEXIST "܂B"
#define _EXE "s"
#define _STD "W"
#define _WIN "EBhE"
#define _SCR "XN["
#define _FILE "t@C"
#define _RUN "^C"
#define _HSPRT "hsprt"
#define _INI "compile.ini"
#define _PACK "packfile"
#define _DATA "data"
#define _HSP2 "hsp2 "
#define _DPM ".dpm"
#define _ES "\\"
#define _NL "\n"

;============================================================
;   R}hC
;
;	1s	R}h	1 CompileAndExecute
;				2 Compile
;				3 Execute
;				4 ShowError
;				5 MakeObject
;				6 MakeStartAX
;				7 ExecuteWithLog
;				8 MakeDPM
;				9 MakeEXE
;			
;	2sځ` R}hɂ

	nindex = 15
	dllproc "GetSysColor", nindex, 1, D_USER
	sys_color.0 = dllret & $FF, dllret >>8 & $FF, dllret >>16 & $FF

#module "HSP-Conpiler"

#deffunc _Compile val, int
	mref string, 56
	mref value,  1
	mref sta, 64

	hsc_ini@ string.0
	hsc_refname@ string.1
	hsc_objname@ string.2
	hsc_comp@ value
return

#deffunc _ShowError
	sdim errorMes, 32768
	hsc_getmes@ errorMes

	screen 2, 430, 310, 14 : title "ʃ|[g"
	color sys_color@.0, sys_color@.1, sys_color@.2 : boxf

	sysfont 17 : objmode 1
	pos 10, 10   : objsize 410, 260 : mesbox errorMes, 410, 260, 0, 32768
	pos 330, 280 : objsize 90, 20   : button _CLOSE@, *close_showerror
	gsel 2,2
stop

*close_showerror
return

#global

	chdir exedir

;============================================================
;   R}hC
	sdim cmdlin, 4096
	cmdlin = cmdline
	notesel cmdlin
	notemax nmax
	if nmax {
		sdim string, 512, nmax
	}
	else {
		sdim string, 512
	}
	repeat nmax
		noteget string.cnt, cnt
		mes string.cnt
	loop

	if string == "CompileAndExecute": gosub *CompileAndExecute
	if string == "Compile"		: gosub *Compile
	if string == "Execute"		: gosub *Execute
	if string == "ShowError"	: gosub *ShowError
	if string == "MakeObject"	: gosub *MakeObject
	if string == "MakeStartAX"	: gosub *MakeStartAX
	if string == "ExecuteWithLog"	: gosub *ExecuteWithLog
	if string == "MakeDPM"		: gosub *MakeDPM
	if string == "MakeEXE"		: gosub *MakeEXE

end

;============================================================
;   RpC
;
;	0 Compile
;	1 RpCt@C̃pX
;	2 fobOEBhEɕ\t@C
;	3 o͂IuWFNgt@C
;	4 s[himode & 1 == true ŃtXN[Amode & 2 == true ŃfobOEBhE\j
;
*Compile
	sdim dir, 4096
	extract dir, string.1, 1

	chdir dir

	dim time_stanp, 24
	exist dir + string.3
	if strsize != -1 {
		sxtime time_stanp, dir + string.3, 0
	}

	sdim comString, 512, 3
	comString = string.1, string.2, string.3
	_Compile comString, mode

	com_err = 8
	exist dir + string.3
	if strsize != -1 {
		dim time_stanp_2, 24
		sxtime time_stanp_2, dir + string.3, 0

		repeat 8, 8
			if time_stanp.cnt != time_stanp_2.cnt : com_err--
		loop
	}
	if com_err == 8 {
		_ShowError
		end
	}
return

;============================================================
;   s
;
;	0 Execute
;	1 st@C
;	2 s[himode & 1 == true ŃtXN[Amode & 2 == true ŃfobOEBhE\j
;	3` R}hC
;
*Execute
	string.1 = "\"" + string.1 + "\""
	a = ""
	b = string.2
	int b
	if b & 1 : a += "*"
	if b & 2 : a += "@"

	sdim temp, 4096
	temp = exedir + _ES + _HSP2 + a + string.1 + " "

	if nmax > 3 {
		repeat nmax - 3, 3
			temp += string.cnt + _NL
		loop
	}

	exec temp, 0
return

;============================================================
;   RpC{s
;
;	0 CompileAndExecute
;	1 RpCt@C̃pX
;	2 fobOEBhEɕ\t@C
;	3 o͂IuWFNgt@C
;	4 s[himode & 1 == true ŃtXN[Amode & 2 == true ŃfobOEBhE\j
;	5` R}hC
;
*CompileAndExecute
	mode = 1
	gosub *Compile
	a = ""
	b = string.4
	int b
	if b & 1 : a += "*"
	if b & 2 : a += "@"

	chdir dir

	sdim temp, 4096
	temp = exedir + _ES + _HSP2 + a + string.3 + " "

	if nmax > 5 {
		repeat nmax - 5, 5
			temp += string.cnt + _NL
		loop
	}

	exec temp, 0
return

;============================================================
;   G[\
;
;	0 ShowError
;	1 RpCt@C̃pX
;	2 fobOEBhEɕ\t@C
;	3 o͂IuWFNgt@C
;	4 s[himode & 1 == true ŃtXN[Amode & 2 == true ŃfobOEBhE\j
;
*ShowError
	mode = 1
	gosub *Compile
	_ShowError
return

;============================================================
;   IuWFNgt@C쐬
;
;	0 MakeObject
;	1 RpCt@C̃pX
;	2 fobOEBhEɕ\t@C
;	3 o͂IuWFNgt@C
;
*MakeObject
	mode = 0
	gosub *Compile
	dialog string.3 + _MAKE, 0, MESSEGE
return

;============================================================
;   start.ax쐬
;
;	0 MakeStartAX
;	1 RpCt@C̃pX
;	2 fobOEBhEɕ\t@C
;	3 o͂IuWFNgt@C
;
*MakeStartAX
	mode = 0
	gosub *Compile
	dialog "start.ax" + _MAKE, 0, MESSEGE
return

;============================================================
;   ts
;
;	0 ExecuteWithLog
;	1 RpCt@C̃pX
;	2 fobOEBhEɕ\t@C
;	3 o͂IuWFNgt@C
;	4 s[himode & 1 == true ŃtXN[Amode & 2 == true ŃfobOEBhE\j
;	5` R}hC
;
*ExecuteWithLog
	screen 2, 330, 150, 14 : title "t" + _EXE

	color sys_color.0, sys_color.1, sys_color.2 : boxf
	color : sysfont 17
	pos 10, 10
	mes {"sOt@C\"hsplog.txt\"
		Ȃs܂B
		ȉ̍ڂOɕtł܂B"}

	dim log_chk, 16 : log_chk.0 = 1, 1, 1, 1 : objmode 1
	pos 10, 50 : chkbox "sԍ",	 log_chk.0	;ID=0
	pos 10, 70 : chkbox "t",	 log_chk.1	;ID=1
	pos 90, 50 : chkbox "",	 log_chk.2	;ID=2
	pos 90, 70 : chkbox _FILE + "",log_chk.3	;ID=3
	objsize 90, 20
	pos 220, 10 : button _EXE + "Jn", *executeStart
	pos 220, 35 : button _CANSEL, *executeCansel

	gsel 2, 2
stop

*executeStart
	mode = 1
	gosub *Compile

	c = 0
	if log_chk.0 == 1 : c++
	if log_chk.1 == 1 : c+=4
	if log_chk.2 == 1 : c+=2
	if log_chk.3 == 1 : c+=8

	str c, 3
	c = "%" + c

	mode = 1
	gosub *Compile
	a = ""
	b = string.4
	int b
	if b & 1 : a += "*"
	if b & 2 : a += "@"

	chdir dir

	sdim temp, 4096
	temp = exedir + _ES + _HSP2 + c + a + string.3 + " "

	if nmax > 5 {
		repeat nmax - 5, 5
			temp += string.cnt + _NL
		loop
	}

	exec temp, 0

*executeCansel
return

;============================================================
;   DPMt@C쐬
;
;	0 MakeDPM
;	1 packfilêfBNg
;
*MakeDPM
	chdir string.1
	pack_ini _DATA
	pack_make
	dialog _DATA + _DPM + _MAKE, 0, MESSEGE
return

;============================================================
;   EXEt@C쐬
;
;	0 MakeEXE
;	1 packfilêfBNg
;
*MakeEXE
	chdir string.1
	exist curdir + _ES + _PACK
	if strsize == -1 {
		dialog _PACK + "Ă܂B", 1, WARNING
		return
	}

	exe_filename = "" : sdim hrt, 512

	screen 2, 315, 315, 14 : title _EXE + _FILE + "쐬"
	color sys_color.0, sys_color.1, sys_color.2 : boxf

	sdim file_type, 256
	file_type  = _STD + _EXE + _FILE + "iEXEj" + _NL
	file_type += "t" + _SCR + _EXE + _FILE + "iEXEj" + _NL
	file_type += _SCR + "ZCo[iSRCj"
	dim sel_com, 16

	dim run_sel, 16

	color 0, 0, 255 : sysfont 17 : objmode 1
	pos 15, 10 : mes _EXE + _FILE + "(gqȂ)"
	pos 10, 25 : objsize 295, 20 : input exe_filename, 295, 20, 8	;exe_filename ID0

	pos 15, 55 : mes _WIN + "TCY"
	pos 30, 80 : mes "X"
	pos 40, 76 : objsize 80, 20 : input window_x, 80, 20, 4		;xTCY ID1
	pos 140, 80: mes "Y"
	pos 150, 76: objsize 80, 20 : input window_y, 80, 20, 4		;yTCY ID2

	pos 10, 105 : objsize 280, 20 : chkbox "NɃC" + _WIN + "\ɂ", app	;\ ID3

	pos 10, 135 : objsize 280, 20 : combox sel_com, 100, file_type				;t@C` ID4

	pos 15, 170 : mes "gp" + _RUN
	pos 10, 185 : objsize 280, 20 : button _STD + _RUN + "(" + _HSPRT + ")", *ύXi^Cj	;^C ID5
		id = 5 : a = -1 : objsend id, $f4, $03, a, 1
		a = 0 : objsend 5, $f1, 1, a, 1
		run_sel = 5
	pos 10, 205 : objsize 280, 20 : button "g" + _RUN, *ύXi^Cj		;^C ID6
		id = 6 : a = -1 : objsend id, $f4, $03, a, 1
	pos 10, 225 : objsize 230, 20 : input hrt, 230, 20, 512					;^Cꏊ ID7
		enable 7, 0
	pos 245, 225: objsize 60, 20 : button "Q", *QƁi^Cj				;Q ID8
		enable 8, 0

	pos 120, 260 : objsize 90, 20 : button _OK, *OKist@Cj				;OK ID9
	pos 220, 260 : objsize 90, 20 : button _CANSEL, *LZist@Cj		;LZ ID10

	exist exedir + _ES + _INI
	if strsize == -1 {
		exe_filename = ""
		window_x = 640
		window_y = 480
		app = 0
		sdim hrt, 512 : hrt = curdir + _ES + _HSPRT
	}
	else {
		sdim ini, strsize + 1
		bload exedir + _ES + _INI, ini, strsize

		index = 0
		sdim temp, 512

		getstr temp, ini, index, '=' : index += strsize
		getstr exe_filename, ini, index : index += strsize

		getstr temp, ini, index, '=' : index += strsize
		getstr window_x, ini, index, ',' : index += strsize : int window_x
		getstr window_y, ini, index : index += strsize : int window_y

		getstr temp, ini, index, '=' : index += strsize
		getstr app, ini, index : index += strsize : int app

		getstr temp, ini, index, '=' : index += strsize
		getstr hrt, ini, index : index += strsize
	}

	objprm 0, exe_filename
	objprm 1, window_x
	objprm 2, window_y
	objprm 3, app
	objprm 7, hrt

	gsel 2, 2
stop

*ύXi^Cj

	run_sel = stat

	a = 0
	objsend 5, $f1, 0, a, 1	;id=4 OFF
	objsend 6, $f1, 0, a, 1	;id=5 OFF
	objsend run_sel, $f1, 1, a, 1	;wParam̒l1ɐݒ(ON)

	if run_sel == 5 {
		enable 7, 0
		enable 8, 0
	}
	else {
		enable 7, 1
		enable 8, 1
	}
stop

*QƁi^Cj

	sdim cur_dir, 512
	cur_dir = curdir

	sdim rt_folder, 512
	extract rt_folder, hrt, 1

	skiperr 1
		chdir rt_folder
		if err != 0 : chdir cur_dir
	skiperr 0

	alloc buf, buf_size
	alloc info, info_size

	buf = _FILE + "J" : info = curdir
	multiopen buf, info
	buf = buf_size : buf.1 = info_size
	info = "hrţ(*.hrt)|*.hrt|"
	multiopen buf, info,1

	if stat {
		notesel buf
		notemax SelectFileMax

		if SelectFileMax = 1 {
			sdim hrt, 512
			noteget hrt, 0
			objprm 7, hrt
		}
		else {
			dialog _FILE + "1Iׂ܂B", 1, WARNING
		}
	}

	chdir cur_dir
stop

*OKist@Cj

	pack_ini exe_filename
	pack_opt window_x, window_y, app
	if run_sel == 5 {
		exist exedir + _ES + _HSPRT
		if strsize == -1 {
			dialog _HSPRT + _NOEXIST, 1, WARNING
			stop
		}
		pack_rt exedir + _ES + _HSPRT
	}
	else {
		exist hrt
		if strsize == -1 {
			dialog _RUN + _FILE + _NOEXIST, 1, WARNING
			stop
		}
		pack_rt hrt
	}

	pack_make
	pack_exe sel_com

	exist exe_filename + _DPM
	if strsize > 0 {
		delete exe_filename + _DPM
	}

	sdim temp, 4096
	temp += "FileName=" + exe_filename + _NL
	temp += "WindowSize=" + window_x + "," + window_y + _NL
	temp += "WinsowStatus=" + app + _NL
	temp += "RuntimePath=" + hrt
	strlen length, temp
	bsave exedir + _ES + _INI, temp, length

;	_ShowError
	dialog _EXE + _FILE + _MAKE, 0, MESSEGE
return

*LZist@Cj
return

